/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
/*~									    														  ~*/
/*~	    		        Copyright  1998 Corpus Inc.    							  ~*/
/*~														 									     ~*/
/*~   		  		Freeware Resource Font Component Library 	    				  ~*/
/*~									    														  ~*/
/*~		 		  Written by Alper YAZGAN,  alper@mda.com.tr         			  ~*/
/*~									    														  ~*/
/*~   		    	      		X-MCMXCVIII				    							  ~*/
/*~									    														  ~*/
/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
#ifndef ResourceTTFontH
#define ResourceTTFontH
//---------------------------------------------------------------------------
#ifndef RC_INVOKED
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <DsgnIntf.hpp>
#include <Windows.hpp>
#include <Messages.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#endif // RC_INVOKED
//---------------------------------------------------------------------------
#define SBaseResourceID								0x0000
#define SENotEnoughMemory								(SBaseResourceID + 1)
#define SEFontNotFoundInRegistry					(SBaseResourceID + 2)
#define SEFontFileNotFound 							(SBaseResourceID + 3)
#define SEFontNotInstalled							(SBaseResourceID + 4)
#define SEFontNotBeChangedAtRuntime				(SBaseResourceID + 5)
#define SComponentPaletteName 						(SBaseResourceID + 6)
#define SResourceTTFontEditorCaption  			(SBaseResourceID + 7)
#define SLabelPromptCaption           			(SBaseResourceID + 8)
#define SEFontNotInstalledPermanently 			(SBaseResourceID + 9)
#define SEFontPermInsPropNotBeChangedAtRuntime	(SBaseResourceID + 10)
#define SEWrongLZRWSignature							(SBaseResourceID + 11)
#define SEFontFileNotBeLoaded						(SBaseResourceID + 12)
//---------------------------------------------------------------------------
#define LZCOPIED 										0x80
#define LZCOMPRESSED 									0x40
#define MAXLZSTREAMSIGNATURE							8
//---------------------------------------------------------------------------
#ifndef RC_INVOKED
//---------------------------------------------------------------------------
//class DELPHICLASS EResourceTTFont;
class PACKAGE EResourceTTFont : public Exception
{
public:
	__fastcall EResourceTTFont(int Ident);
	__fastcall EResourceTTFont(int Ident, Variant Arg);
};
//---------------------------------------------------------------------------
//class DELPHICLASS TLZStream;
class PACKAGE TLZStream
{
	typedef Byte LZBufferArray[MAXSHORT+16];
	typedef LZBufferArray *PLZBufferArray;
	typedef short LZHashTable[4096];
	typedef LZHashTable *PLZHashTable;
	static const char Signature[MAXLZSTREAMSIGNATURE];
	PLZHashTable Hash;
	bool GetMatch(PLZBufferArray Source, Word X, Word SourceSize,PLZHashTable Hash, Word &Size, Word &Pos);
	Word __fastcall Compression(PLZBufferArray Source, PLZBufferArray Dest, Word SourceSize);
	Word __fastcall DeCompression(PLZBufferArray Source, PLZBufferArray Dest, Word SourceSize);
public:
	__fastcall TLZStream(void);
	__fastcall ~TLZStream(void);
	void __fastcall Compress(TStream *InStream, TStream *OutStream, int InSize);
	int __fastcall DeCompress(TStream *InStream, TStream *OutStream);
};
//---------------------------------------------------------------------------
//class DELPHICLASS TVersionInfo;
class PACKAGE TVersionInfo : public TPersistent
{
	enum TVersionField {	vtCompanyName, vtFileDescription, vtFileVersion, vtInternalName, vtLegalCopyright, vtLegalTrademarks,
								vtAuthor, vtOriginalFilename, vtProductName,	vtProductVersion, vtComments, vtBuildFlags };
	Byte *VersionInfo;
	AnsiString FCompanyName;
	AnsiString FFileDescription;
	AnsiString FFileVersion;
	AnsiString FInternalName;
	AnsiString FLegalCopyright;
	AnsiString FLegalTrademarks;
	AnsiString FAuthor;
	AnsiString FOriginalFilename;
	AnsiString FProductName;
	AnsiString FProductVersion;
	AnsiString FComments;
	AnsiString FBuildFlags;
	AnsiString __fastcall GetVersionFieldFromResource(TVersionField versionField);
protected:
	AnsiString __fastcall GetVersionField(int Index);
	void __fastcall SetVersionField(int Index, AnsiString Value) {}
public:
	__fastcall TVersionInfo(void);
	__fastcall ~TVersionInfo(void);
__published:
	__property AnsiString CompanyName = { read = GetVersionField, write = SetVersionField, index = vtCompanyName, stored = false };
	__property AnsiString FileDescription = { read = GetVersionField, write = SetVersionField, index = vtFileDescription, stored = false };
	__property AnsiString FileVersion = { read = GetVersionField, write = SetVersionField, index = vtFileVersion, stored = false };
	__property AnsiString InternalName = { read = GetVersionField, write = SetVersionField, index = vtInternalName, stored = false };
	__property AnsiString LegalCopyright = { read = GetVersionField, write = SetVersionField, index = vtLegalCopyright, stored = false };
	__property AnsiString LegalTrademarks = { read = GetVersionField, write = SetVersionField, index = vtLegalTrademarks, stored = false };
	__property AnsiString Author = { read = GetVersionField, write = SetVersionField, index = vtAuthor, stored = false };
	__property AnsiString OriginalFilename = { read = GetVersionField, write = SetVersionField, index = vtOriginalFilename, stored = false };
	__property AnsiString ProductName = { read = GetVersionField, write = SetVersionField, index = vtProductName, stored = false };
	__property AnsiString ProductVersion = { read = GetVersionField, write = SetVersionField, index = vtProductVersion, stored = false };
	__property AnsiString Comments = { read = GetVersionField, write = SetVersionField, index = vtComments, stored = false };
	__property AnsiString BuildFlags = { read = GetVersionField, write = SetVersionField, index = vtBuildFlags, stored = false };
};
//---------------------------------------------------------------------------
//class DELPHICLASS TResourceTTFontName;
class PACKAGE TResourceTTFontName : public TPersistent
{
	TComponent *PropertyOwner;
	TFontName FTTFontName;
	TFileName __fastcall FindTTFontFile(TFontName FontName) const;
protected:
	virtual void __fastcall SetTTFontName(TFontName Value);
	virtual TFileName __fastcall GetTTFontFileName(void);
public:
	__fastcall TResourceTTFontName(TComponent *APropertyOwner);
	virtual void __fastcall Assign(TPersistent *Source);
	bool __fastcall operator == (const TResourceTTFontName &AResourceTTFontName) const;
	__property TFileName TTFontFileName = { read = GetTTFontFileName };
__published:
	__property TFontName TTFontName = { read = FTTFontName, write = SetTTFontName };
};
//---------------------------------------------------------------------------
//class DELPHICLASS TResourceTTFont;
class PACKAGE TResourceTTFont : public TComponent
{
	TVersionInfo *FVersionInfo;
	bool FInstallPermanently;
	TResourceTTFontName *FResourceTTFontName;
	TMemoryStream *TTFontResourceStream;
	TFileName InstalledTTFontFileName;
	bool FontInstalled;
	void __fastcall GetFontResource(void);
	void __fastcall AddFontResource(void);
	void __fastcall RemoveFontResource(void);
	bool __fastcall CheckIfIntalled(void) const;
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall DefineProperties(TFiler *Filer);
	void __fastcall ReadTrueTypeFontResource(TStream *Stream);
	void __fastcall WriteTrueTypeFontResource(TStream *Stream);
	void __fastcall SetAbout(TVersionInfo *Value) {}
	virtual void __fastcall SetInstallPermanently(bool Value);
	virtual void __fastcall SetResourceTTFontName(TResourceTTFontName *Value);
public:
	__fastcall TResourceTTFont(TComponent *Owner);
	__fastcall virtual ~TResourceTTFont(void);
__published:
	__property TVersionInfo *About = { read = FVersionInfo, write = SetAbout };
	__property bool InstallPermanently = { read = FInstallPermanently, write = SetInstallPermanently, default = true };
	__property TResourceTTFontName *ResourceTTFontName = { read = FResourceTTFontName, write = SetResourceTTFontName };
};
//---------------------------------------------------------------------------
//class DELPHICLASS TResourceTTFontAboutPropertyEditor;
class PACKAGE TResourceTTFontAboutPropertyEditor : public TClassProperty
{
public:
	__fastcall TResourceTTFontAboutPropertyEditor(void);
	virtual TPropertyAttributes __fastcall GetAttributes(void);
	virtual void __fastcall Edit(void);
};
//---------------------------------------------------------------------------
//class DELPHICLASS TResourceTTFontNamePropertyEditor;
class PACKAGE TResourceTTFontNamePropertyEditor : public TClassProperty
{
public:
	__fastcall TResourceTTFontNamePropertyEditor(void);
	virtual TPropertyAttributes __fastcall GetAttributes(void);
	virtual void __fastcall Edit(void);
};
//---------------------------------------------------------------------------
//class DELPHICLASS TResourceTTFontComponentEditor;
class PACKAGE TResourceTTFontComponentEditor : public TDefaultEditor
{
	int CurrentPropertyIndex;
public:
	__fastcall virtual TResourceTTFontComponentEditor(TComponent *AComponent, TFormDesigner *ADesigner);
	virtual int __fastcall GetVerbCount(void);
	virtual AnsiString __fastcall GetVerb(int Index);
	virtual void __fastcall ExecuteVerb(int Index);
	virtual void __fastcall EditProperty(TPropertyEditor *PropertyEditor, bool &Continue, bool &FreeEditor);
};
//---------------------------------------------------------------------------
//class DELPHICLASS TFormResourceTTFontEditor;
class PACKAGE TFormResourceTTFontEditor : public TForm
{
__published:
	TBitBtn *BitBtnOK;
	TBitBtn *BitBtnCancel;
	TLabel *LabelPrompt;
	TListBox *ListBoxTTFonts;
	TStaticText *StaticTextSample;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ListBoxTTFontsDrawItem(TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State);
	void __fastcall ListBoxTTFontsMeasureItem(TWinControl *Control, int Index, int &Height);
	void __fastcall ListBoxTTFontsClick(TObject *Sender);
	void __fastcall ListBoxTTFontsDblClick(TObject *Sender);
private:
	TResourceTTFontName *FResourceTTFontName;
protected:
	virtual void __fastcall SetResourceTTFontName(TResourceTTFontName *Value);
public:
	__fastcall TFormResourceTTFontEditor(TComponent *Owner);
	__fastcall virtual ~TFormResourceTTFontEditor(void);
	__property TResourceTTFontName *ResourceTTFontName = { read = FResourceTTFontName, write = SetResourceTTFontName };
};
//----------------------------------------------------------------------------
//class DELPHICLASS TFormAbout;
class PACKAGE TFormAbout : public TForm
{
__published:
	TImage *ImageIcon;
	TLabel *LabelProductName;
	TLabel *LabelProductInfo;
	TBevel *BevelBottomLine;
	TBitBtn *BitBtnOk;
public:
	virtual __fastcall TFormAbout(TComponent *Owner);
};
//----------------------------------------------------------------------------
static int CALLBACK GetTrueTypeFont(PEnumLogFont EnumLogFont, PNewTextMetric NewTextMetric, DWORD FontType, LPARAM LParam);
static void GetTrueTypeFonts(TStrings *TTFonts);
static AnsiString GetFontsDirectory(void);
//----------------------------------------------------------------------------
#endif // RC_INVOKED
//----------------------------------------------------------------------------
#endif
